/*******************************************************************************

    EFEITOS SONOROS



    C/ PIC12F675


    AUTOR: CLAUDIO LARIOS

    DATA:14/07/2020



    USO DIDTICO
    ESTE ARQUIVO  PARTE INTEGRANTE DO BLOG LARIOS.TECNOLOGIA.WS

*******************************************************************************/
#include <12F675.h>
#device adc=10
#use delay(clock=4000000)
#fuses NOWDT,INTRC_IO, NOCPD, NOPROTECT, NOMCLR, PUT, BROWNOUT

//bytes
#byte  TRISIO = 0x85
#byte  GPIO   = 0x05
#byte  CMCOM  = 0X19
#byte  ANSEL  = 0X9F
#byte  TMR0   = 0X01

//pinos do lcd (metodo Lariosplex - 3 fios)

#bit piezo   = 0x05.5  //pino 2 sada de som
#bit sw    = 0x05.3  //pino 4 sw seleo de faixa





//variveis globais

unsigned int8 cnt, auxb, auxc,auxd,auxe;

/*******************************************************************************
                          SUBROTINAS
*******************************************************************************/

void inverte_saida(){
  unsigned int8 auxa;

  for(auxa=0;auxa<cnt;auxa++){ delay_us(6);}
  piezo= piezo ^ 1;
}


void delay_entre_sons(){//delay entre os sons 
   delay_ms(1000);
}

void som_2passarinhos(){

//randomiza nmero de piados do passarinho 1 usando o timer0
   auxe=tmr0;
   auxe= auxe>>4;
   if(auxe>8){auxe=2; tmr0=tmr0 ^0b10100111;}
   auxe=auxe + 1;

   //passarinho 1
   for(auxd=0; auxd<auxe;auxd++){//numero de piados
    cnt=10;//frequencia
     for(auxc=0; auxc<5;auxc++){//passo

       for(auxb=0; auxb<50;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = cnt - 8;
       }
       else{
         cnt = cnt + 2;
       }
     }
     delay_ms(150);
    }

    delay_ms(1000);

 //passarinho 2
   for(auxd=0; auxd<3;auxd++){//numero de execues
     cnt=10;//frequencia
     for(auxc=0; auxc<5;auxc++){//passo
       for(auxb=0; auxb<40;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = cnt - 3;
       }
       else{
         cnt = cnt + 3;
       }
     }
     delay_ms(300);
    }
    //randomiza delay pelo timer 0
     if(tmr0>128){
    delay_ms(5000);
     }
     else{
       if(tmr0<100){
        delay_ms(1000);
       }
       else{
         delay_ms(500);
       }

     }
      delay_ms(1000);
}

void som_campainha_telefone(){

    for(auxd=0; auxd<3;auxd++){//numero de execues
      cnt=100;//frequencia

      for(auxc=0; auxc<20;auxc++){//passo

       for(auxb=0; auxb<50;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt^ 0b00001111;  //0b11010110;
     }
     delay_ms(2000);
    }
 }

void som_sirene1(){
    for(auxd=0; auxd<10;auxd++){//numero de execues
   // cnt=40;//frequencia
     for(auxc=0; auxc<50;auxc++){//passo

       for(auxb=0; auxb<15;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = 0;
       }
       else{
         cnt = cnt + 1;
       }
     }
    }
 }

 void som_sirene2(){//estilo = rpida
  unsigned int8 auxj=0;
    for(auxd=0; auxd<100;auxd++){//numero de execues
   // cnt=40;//frequencia
     for(auxc=0; auxc<50;auxc++){//passo

       for(auxb=0; auxb<3;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>64)auxj=1;
       if(cnt==1)auxj=0;
       if(auxj==1){
         cnt = cnt - 1;
       }
       else{
         cnt = cnt + 1;
       }
     }
    }
 }

 void som_sirene3(){
    //sirene legal (alerta)
    for(auxd=0; auxd<50;auxd++){//numero de execues
    cnt=100;//frequencia
     for(auxc=0; auxc<10;auxc++){//passo

       for(auxb=0; auxb<40;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt - 2;
     }
    }
 }

 void som_sirene4(){
    //sirene alarme rpido 1 (toooouu! tooooouuu! toooouuu!)
    for(auxd=0; auxd<30;auxd++){//numero de execues
    cnt=20;//frequencia
     for(auxc=0; auxc<30;auxc++){//passo

       for(auxb=0; auxb<12;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = cnt - 2;
       }
       else{
         cnt = cnt + 2;
       }
     }
    }
 }


void som_sirene5(){
   //sirene  disparos rpidos (usar junto com outra)
    for(auxd=0; auxd<50;auxd++){//numero de execues
    cnt=20;//frequencia
     for(auxc=0; auxc<10;auxc++){//passo

       for(auxb=0; auxb<12;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = cnt - 5;
       }
       else{
         cnt = cnt + 5;
       }
     }
    }
}

void som_sirene6(){

   //sirene (iaaauuuuu!  iiiaaauuu!)
    for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=20;//frequencia
     for(auxc=0; auxc<10;auxc++){//passo

       for(auxb=0; auxb<80;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = cnt - 5;
       }
       else{
         cnt = cnt + 5;
       }
     }
    }
}

void som_sirene7(){
//sirene tipo policia
    for(auxd=0; auxd<30;auxd++){//numero de execues
    cnt=39;//frequencia
     for(auxc=0; auxc<12;auxc++){//passo

       for(auxb=0; auxb<6;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt - 5;
     }
    }
}

void som_sirene8(){
 //sirene alarme rpido 1
    for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=40;//frequencia
     for(auxc=0; auxc<50;auxc++){//passo

       for(auxb=0; auxb<5;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = cnt - 2;
       }
       else{
         cnt = cnt + 6;
       }
     }
    }
}

void som_sirene9(){

  //som de arma espacial 1 (tchooo') lento
    for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=40;//frequencia
     for(auxc=0; auxc<50;auxc++){//passo

       for(auxb=0; auxb<9;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = cnt - 2;
       }
       else{
         cnt = cnt + 6;
       }
     }
    }
}

void som_sirene10(){
//gun space
    for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=39;//frequencia
     for(auxc=0; auxc<18;auxc++){//passo

       for(auxb=0; auxb<9;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt - 8;
     }
    }
}

void som_sirene11(){
 //space gun 5 rpida (metralhando)
    for(auxd=0; auxd<20;auxd++){//numero de execues
    cnt=10;//frequencia
     for(auxc=0; auxc<10;auxc++){//passo

       for(auxb=0; auxb<30;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = cnt - 7;
       }
       else{
         cnt = cnt + 3;
       }
     }
    }
}
void som_sirene12(){

       //space gun 4 rpida (metralhando)
    for(auxd=0; auxd<20;auxd++){//numero de execues
    cnt=20;//frequencia
     for(auxc=0; auxc<30;auxc++){//passo

       for(auxb=0; auxb<6;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = cnt - 2;
       }
       else{
         cnt = cnt + 4;
       }
     }
    }
}
void som_sirene13(){
//gun space2
    for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=44;//frequencia
     for(auxc=0; auxc<18;auxc++){//passo

       for(auxb=0; auxb<9;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt - 8;
     }
    }
}

void som_sirene14(){
  //space gun 3 (tchuuu! tchuuu!)
    for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=20;//frequencia
     for(auxc=0; auxc<30;auxc++){//passo

       for(auxb=0; auxb<12;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = cnt - 2;
       }
       else{
         cnt = cnt + 4;
       }
     }
    }
}

void som_sirene15(){
  //extranha (doleto bum doleto bum)
    for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=37;//frequencia
     for(auxc=0; auxc<10;auxc++){//passo

       for(auxb=0; auxb<40;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt - 20;
     }
    }
}

void som_sirene16(){
 //poim poim
    for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=100;//frequencia
     for(auxc=0; auxc<10;auxc++){//passo

       for(auxb=0; auxb<40;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt - 40;
     }
    }
}
void som_sirene17(){

  //bp
    for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=20;//frequencia
     for(auxc=0; auxc<10;auxc++){//passo

       for(auxb=0; auxb<80;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt - 50;
     }
    }
}

void som_sirene18(){
 //sirene alarme rpido 1
    for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=40;//frequencia
     for(auxc=0; auxc<50;auxc++){//passo

       for(auxb=0; auxb<15;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = cnt ^ 0b10000000;
       }
       else{
         cnt = cnt + 1;
       }
     }
    }
}

void som_sirene19(){
   for(auxd=0; auxd<10;auxd++){//numero de execues
     for(auxc=0; auxc<50;auxc++){//passo
       cnt=20;
       for(auxb=0; auxb<15;auxb++){//permanncia
         inverte_saida();
       }
       cnt=15;
       for(auxb=0; auxb<15;auxb++){//permanncia
         inverte_saida();
       }
     }
    }
}

void som_sirene20(){//2 tons
   for(auxd=0; auxd<10;auxd++){//numero de execues
      cnt=200;
      for(auxc=0; auxc<32;auxc++){//passo
        for(auxb=0; auxb<15;auxb++){//permanncia
          inverte_saida();
        }
      }
      cnt=140;
      for(auxc=0; auxc<48;auxc++){//passo
        for(auxb=0; auxb<15;auxb++){//permanncia
          inverte_saida();
        }
      }
   }
}

void som_sirene21(){//campainha telefone 2
  cnt=64;
  for(auxd=0; auxd<3;auxd++){//numero de execues
     for(auxc=0; auxc<10;auxc++){//passo
       cnt=64;
       for(auxb=0; auxb<50;auxb++){//permanncia
         inverte_saida();
       }
       cnt=72;
       for(auxb=0; auxb<50;auxb++){//permanncia
         inverte_saida();
       }
     }
     delay_ms(2000);
    }
}

void som_sirene22(){
  for(auxe=0;auxe<3;auxe++){//numero de execues
    cnt=100;//frequencia
  
    for(auxd=0; auxd<4;auxd++){//passo 2

     for(auxc=0; auxc<10;auxc++){//passo

       for(auxb=0; auxb<40;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt - 40;
     }
    }
    cnt=112;
  }
}

void som_sirene23(){
 for(auxe=0; auxe<5;auxe++){//numero de execues
    cnt=70;//frequencia
  //poim poim
    for(auxd=0; auxd<5;auxd++){//numero de execues

     for(auxc=0; auxc<15;auxc++){//passo

       for(auxb=0; auxb<40;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt - 50;
     }
    }
    cnt=79;
 } 
}

void som_sirene24(){
 for(auxd=0; auxd<3;auxd++){//numero de execues
    cnt=10;//frequencia
     for(auxc=0; auxc<15;auxc++){//passo

       for(auxb=0; auxb<70;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt - 12;
     }
    }
}



/*******************************************************************************
                        ROTINA MAIN
*******************************************************************************/

void main() {

   CMCOM = 7;//desliga comparadores
   GPIO = 0;//zera tudo
   TRISIO = 0b011111;//ajusta entradas e sadas
   ANSEL = 0;// desabilita ports p/ conversores ADC

   /*******************************************************************************
           LOOP PRINCIPAL DE REPETIO
*******************************************************************************/


   for(;;){


  //      som_2passarinhos();//som de piado de passarinho
  //      delay_entre_sons();
  
  
        som_campainha_telefone();//campainha de telefone 1
        delay_entre_sons();
        
        som_sirene1();  // arma espacial
        delay_entre_sons();
        
        som_sirene2();// rapida 
        delay_entre_sons();
        
        som_sirene3(); //alerta
        delay_entre_sons();
        
        som_sirene4();
        delay_entre_sons();
        
        som_sirene5();
        delay_entre_sons();
        
        som_sirene6();
        delay_entre_sons();
        
        som_sirene7();
        delay_entre_sons();
        
        som_sirene8();
        delay_entre_sons();
        
        som_sirene9(); //arma espacial (lenta)
        delay_entre_sons();
        
        som_sirene10(); //arma espacial (rpida)
        delay_entre_sons();
        
        som_sirene11(); //arma espacial (ultra rpida)
        delay_entre_sons();
        
        som_sirene12(); //metralhadora espacial
        delay_entre_sons();
        
        som_sirene13();
        delay_entre_sons();
        
        som_sirene14();
        delay_entre_sons();
        
        som_sirene15();//estranha 1
        delay_entre_sons();
        
        som_sirene16();//estranha 2
        delay_entre_sons();
        
        som_sirene17();//estranha 3
        delay_entre_sons();
        
        som_sirene18();//sirene
        delay_entre_sons();
        
        som_sirene19();// buzina
        delay_entre_sons();
        
        som_sirene20();//sirene bitonal (similar a francesa)
        delay_entre_sons();
        
        som_sirene21();//campainha de telefone 2
        delay_entre_sons();
          
        som_sirene22();// estranha 4
        delay_entre_sons();
            
    
        som_sirene23();//estranha 5 (parece uma risada)
        delay_entre_sons();
  
        som_sirene24();//estranha 6
        delay_entre_sons();



   }//for()
}//main()


/*
































   }//for(;;)

}//void main()


*/
